AppTitle "EasyIDE"

Const xMax=640,yMax=480
Win=CreateWindow("EasyIDE",ClientWidth(Desktop())/2-xMax/2,ClientHeight(Desktop())/2-yMax/2,xMax,yMax,0,43)

toolbar=CreateToolBar(".\data\toolbar.bmp",0,0,100,20,Win)
SetToolBarTips toolbar,"New,Open,Save,Run,Compile/Execute,Command Reference"

Global textarea=CreateTextArea(0,35,xMax,yMax-30,win)
SetTextAreaFont textarea,LoadFont("fixedsys",20)
SetTextAreaTabs textarea,4
SetGadgetLayout textarea,1,1,1,1

SetStatusText win,"New."
Repeat
	Select WaitEvent(1)
		Case $803
			End 
		Case $401
			Select EventSource() 
				Case toolbar
					Select EventData()
						Case -1
							adress$=""
							SetTextAreaText textarea,""
							SetStatusText win,"New."
						Case 0
							adress$=RequestFile("Open...","C",False)
							If adress$<>"" Then
								SetTextAreaText textarea,FOpenFile(adress$)
								SetStatusText win,"Opened.("+adress$+")"
							Else 
							SetStatusText win,"Canceled"
						EndIf
						
						Case 1
							If adress$="" Then
								adress$=RequestFile("Save...","C",True,"source.c")
								If adress$<>0 Then
									FSaveFile$(adress$)
									SetStatusText win,"Saved.("+adress$+")"
								Else 
									SetStatusText win,"Canceled."
								EndIf
							Else
								FSaveFile$(adress$)
								SetStatusText win,"Saved.("+adress$+")"
							EndIf 
						Case 2
							FSaveFile$("tmp.c")
							CreateBat("tmp.c",True)
							ExecFile ".\data\compile.bat"
							
						Case 3
							If adress$="" Then
								Notify "You have to save this C source file."
							Else 	
								CreateBat(adress$,False)
								ExecFile ".\data\compile.bat"
								Notify "Compiled, for more, see Consol."
							EndIf
						Case 4
							ExecFile ".\data\comref.exe"
					End Select
			End Select
	End Select
Forever

Function FOpenFile$(txt$)
	Local file=ReadFile(txt$)
	st$=""
	While Not Eof(file)
		st$=st$+Chr(ReadByte(file))
	Wend
	CloseFile file
	Return st$
End Function

Function FSaveFile$(txt$)
	Local fileout=WriteFile(txt$)
	If fileout=0 Then Notify "Error":Return
	For i= 1 To Len(TextAreaText(textarea))
		WriteByte fileout,Asc(Mid(TextAreaText(textarea),i,1))
	Next
	CloseFile fileout
End Function

Function CreateBat(in$,condt)
	Local file=WriteFile(".\data\compile.bat")
	WriteLine file,"@echo off"
	WriteLine file,"echo Compiling..."
	WriteLine file,"gcc -o "+Left$(in$,Len(in$)-2)+" "+in$
	WriteLine file,"echo Compiling tried."
	If condt Then WriteLine file,"start tmp.exe"
	WriteLine file,"pause"
	
	CloseFile file
End Function 














